
INSERT INTO `configuration` ( `configuration_id` , `configuration_title` , `configuration_key` , `configuration_value` , `configuration_description` , `configuration_group_id` , `sort_order` , `last_modified` , `date_added` , `use_function` , `set_function` ) VALUES ('', 'Enable Group File Download?', 'DOWNLOADS_CONTROLLER_FILEGROUP_STATUS', 'Yes', 'Do you want to enable group file for download? - Default=Yes', '13', '93', NOW(), NOW(), NULL , 'tep_cfg_select_option(array(\'Yes\', \'No\'), ');

ALTER TABLE `products_attributes_download` ADD `products_attributes_filegroup_id` INT( 11 ) NULL AFTER `products_attributes_filename` ;

CREATE TABLE `products_attributes_download_groups` (
`download_group_id` INT( 11 ) NOT NULL ,
`download_group_name` VARCHAR( 255 ) NULL ,
`language_id` INT( 11 ) NOT NULL ,
PRIMARY KEY ( `download_group_id` , `language_id` )
) ENGINE = MYISAM ;

CREATE TABLE `products_attributes_download_groups_files` (
`download_groups_file_id` INT( 11 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,
`download_group_id` INT( 11 ) NOT NULL ,
`download_group_filename` VARCHAR( 255 ) NOT NULL
) ENGINE = MYISAM ;

ALTER TABLE `products_attributes_download_groups_files` DROP PRIMARY KEY ,
ADD PRIMARY KEY ( `download_groups_file_id` , `download_group_id` ) ;

CREATE TABLE `products_attributes_download_groups_to_files` (
`download_groups_file_id` INT( 11 ) NOT NULL ,
`language_id` INT( 11 ) NOT NULL ,
`download_group_file_description` VARCHAR( 255 ) NULL ,
PRIMARY KEY ( `download_groups_file_id` , `language_id` )
) ENGINE = MYISAM ;
